"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactApollo = require("react-apollo");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _mutation = require("./graphql/mutation");

var _query = require("./graphql/query");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CacheEnabledFeatures =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CacheEnabledFeatures, _React$Component);

  function CacheEnabledFeatures() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CacheEnabledFeatures);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CacheEnabledFeatures)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      isLoading: true,
      hasError: false,
      isReady: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "componentDidMount",
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      var client, _ref2, data, enabledFeatures;

      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              client = _this.props.client;
              _context.prev = 1;
              _context.next = 4;
              return client.query({
                query: _query.queryEnabledFeatures
              });

            case 4:
              _ref2 = _context.sent;
              data = _ref2.data;
              enabledFeatures = data.enabledFeatures.map(function (feature) {
                return {
                  name: feature.name
                };
              });
              _context.next = 9;
              return client.mutate({
                mutation: _mutation.cacheEnabledFeatures,
                variables: {
                  enabledFeatures: enabledFeatures
                }
              });

            case 9:
              _this.setState({
                isReady: true
              });

              _context.next = 16;
              break;

            case 12:
              _context.prev = 12;
              _context.t0 = _context["catch"](1);
              console.error(_context.t0);

              _this.setState({
                hasError: _context.t0
              });

            case 16:
              _context.prev = 16;

              _this.setState({
                isLoading: false
              });

              return _context.finish(16);

            case 19:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 12, 16, 19]]);
    })));

    return _this;
  }

  _createClass(CacheEnabledFeatures, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          hasError = _this$props.hasError,
          loading = _this$props.loading,
          success = _this$props.success,
          children = _this$props.children;
      var _this$state = this.state,
          isLoading = _this$state.isLoading,
          error = _this$state.error,
          isReady = _this$state.isReady;
      if (hasError) return error;
      if (isLoading) return loading;
      if (isReady) return success || children;
    }
  }]);

  return CacheEnabledFeatures;
}(_react.default.Component);

_defineProperty(CacheEnabledFeatures, "propTypes", {
  error: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.node]),
  loading: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.node]),
  success: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.node]),
  children: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element, _propTypes.default.node])
});

_defineProperty(CacheEnabledFeatures, "defaultProps", {
  error: null,
  loading: null,
  success: null,
  children: null
});

var EnabledFeatures = function EnabledFeatures(props) {
  return _react.default.createElement(_reactApollo.ApolloConsumer, null, function (client) {
    return _react.default.createElement(CacheEnabledFeatures, _extends({}, props, {
      client: client
    }));
  });
};

var _default = EnabledFeatures;
exports.default = _default;