"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryFeature = exports.queryEnabledFeatures = void 0;

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  query($name: String!) {\n    isFeatureEnabled(name: $name) @client\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  query {\n    enabledFeatures {\n      name\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

/* Query from GraphQL API the enabled features */
var queryEnabledFeatures = (0, _graphqlTag.default)(_templateObject());
/* Ask whether a feature is enabled or not*/

exports.queryEnabledFeatures = queryEnabledFeatures;
var queryFeature = (0, _graphqlTag.default)(_templateObject2());
exports.queryFeature = queryFeature;