"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.isFeatureEnabled = exports.cacheEnabledFeatures = void 0;

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  query {\n    EnabledFeaturesCache {\n      enabledFeatures {\n        name\n        __typename\n      }\n      __typename\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var enabledFeaturesCacheQuery = (0, _graphqlTag.default)(_templateObject());

var cacheEnabledFeatures = function cacheEnabledFeatures(_, _ref, _ref2) {
  var enabledFeatures = _ref.enabledFeatures;
  var cache = _ref2.cache;
  var EnabledFeatureCacheArray = enabledFeatures.map(function (feature) {
    return {
      name: feature.name,
      __typename: 'EnabledFeatureCache'
    };
  });
  cache.writeQuery({
    query: enabledFeaturesCacheQuery,
    data: {
      EnabledFeaturesCache: {
        enabledFeatures: EnabledFeatureCacheArray,
        __typename: 'EnabledFeaturesCache'
      }
    }
  });
  return true;
};

exports.cacheEnabledFeatures = cacheEnabledFeatures;

var isFeatureEnabled = function isFeatureEnabled(_, _ref3, _ref4) {
  var name = _ref3.name;
  var cache = _ref4.cache;
  var data = cache.readQuery({
    query: enabledFeaturesCacheQuery
  });
  var enabledFeatures = data.EnabledFeaturesCache.enabledFeatures;
  var hasFeature = enabledFeatures.filter(function (feature) {
    return feature.name === name;
  }).length > 0;
  return hasFeature;
};

exports.isFeatureEnabled = isFeatureEnabled;
var _default = {
  Mutation: {
    cacheEnabledFeatures: cacheEnabledFeatures
  },
  Query: {
    isFeatureEnabled: isFeatureEnabled
  }
};
exports.default = _default;